#pragma once


// STD/STL
#include <vector>

// ArmarX
#include <ArmarXCore/core/ComponentPlugin.h>

// RobotAPI
#include <RobotAPI/libraries/aron/core/navigator/data/AllNavigators.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>
#include <RobotAPI/interface/armem/server/ReadingMemoryInterface.h>

#include <RobotAPI/libraries/armem/client/Reader.h>
#include <RobotAPI/libraries/armem/client/MemoryNameSystemComponentPlugin.h>


namespace armarx::armem::client::plugins
{

    class ReaderComponentPlugin : public ComponentPlugin
    {

    public:

        ReaderComponentPlugin(ManagedIceObject& parent, std::string pre);
        ~ReaderComponentPlugin() override;


    private:

        plugins::MemoryNameSystemComponentPlugin* mnsPlugin = nullptr;

    };

}


namespace armarx::armem::client
{

    class ReaderComponentPluginUser :
        virtual public ManagedIceObject,
        virtual public MemoryNameSystemComponentPluginUser
    {

    public:

        ReaderComponentPluginUser();
        ~ReaderComponentPluginUser() override;

        [[deprecated("Use memoryNameSystem member instead of function inherited by ReaderComponentPluginUser.")]]
        virtual armem::data::WaitForMemoryResult useMemoryServer(const std::string& memoryName) override;
        using MemoryNameSystemComponentPluginUser::useMemoryServer;


    protected:

        void setReadingMemoryServer(server::ReadingMemoryInterfacePrx memory);

        Reader memoryReader;


    private:

        plugins::ReaderComponentPlugin* plugin = nullptr;

    };

}
