#pragma once

#include <filesystem>

#include "../base/EntitySnapshotBase.h"
#include "../workingmemory/EntitySnapshot.h"

#include "EntityInstance.h"


namespace armarx::armem::d_ltm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;
        using Base::operator=;


        // Conversion
        void reload(const std::shared_ptr<std::filesystem::path>&);
        wm::EntitySnapshot convert(const aron::typenavigator::NavigatorPtr& expectedStructure) const;

        // FS connection
        void setTo(const wm::EntitySnapshot&);

    private:
        std::filesystem::path _fullPath() const;
        std::filesystem::path _fullPath(const std::filesystem::path&) const;

    public:
        std::shared_ptr<std::filesystem::path> path;
    };
}
