#pragma once

#include "BaseQueryProcessor.h"
#include "../base/EntityQueryProcessorBase.h"

#include "../../../core/diskmemory/Entity.h"

#include "EntityQueryProcessor.h"

namespace armarx::armem::d_ltm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class EntityQueryProcessor :
        virtual public BaseQueryProcessor<d_ltm::Entity, armem::query::data::EntityQuery>,
        virtual public base::query_proc::EntityQueryProcessorBase<d_ltm::Entity>
    {
        using Base = BaseQueryProcessor<d_ltm::Entity, armem::query::data::EntityQuery>;

    public:

        EntityQueryProcessor() :
            Base()
        {}


    private:

        void addResultSnapshot(d_ltm::Entity& result, d_ltm::Entity::ContainerT::const_iterator it) const override
        {
            addResultSnapshot(result, it->second);
        }

        void addResultSnapshot(d_ltm::Entity& result, const d_ltm::EntitySnapshot& snapshot) const override
        {
            result.addSnapshot(snapshot.copy());
        }

    };

}
