#pragma once

#include "BaseQueryProcessor.h"
#include "../base/CoreSegmentQueryProcessorBase.h"

#include "../../../core/longtermmemory/CoreSegment.h"

#include "ProviderSegmentQueryProcessor.h"


namespace armarx::armem::ltm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor :
        virtual public BaseQueryProcessor<ltm::CoreSegment, armem::query::data::CoreSegmentQuery>,
        virtual public base::query_proc::CoreSegmentQueryProcessorBase<ltm::CoreSegment>
    {
        using Base = BaseQueryProcessor<ltm::CoreSegment, armem::query::data::CoreSegmentQuery>;

    public:
        CoreSegmentQueryProcessor() :
            Base()
        {}

    protected:
        virtual ProviderSegmentT providerSegmentProcessorProcess(const armem::query::data::ProviderSegmentQuerySeq& q, const ProviderSegmentT& s) const override
        {
            return providerSegmentProcessor.process(q, s, {armem::query::data::QueryTarget::LTM});
        }

    private:
        ProviderSegmentQueryProcessor providerSegmentProcessor;
    };
}
