#pragma once

#include <RobotAPI/interface/armem/query.h>
#include <RobotAPI/libraries/armem/core/DataMode.h>

#include <RobotAPI/libraries/armem/server/query_proc/base/BaseQueryProcessorBase.h>


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Base class for memory query processors.
     */
    template <class DataT, class QueryT>
    class BaseQueryProcessor :
        virtual public base::query_proc::BaseQueryProcessorBase<DataT, QueryT>
    {
        using Base = base::query_proc::BaseQueryProcessorBase<DataT, QueryT>;

    public:

        BaseQueryProcessor(DataMode dataMode = DataMode::WithData) :
            dataMode(dataMode)
        {}


    protected:

        DataMode dataMode;

    };
}
