#pragma once

#include <RobotAPI/libraries/armem/core/workingmemory/Entity.h>
#include <RobotAPI/libraries/armem/server/query_proc/base/EntityQueryProcessorBase.h>

#include "BaseQueryProcessor.h"


namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class EntityQueryProcessor :
        virtual public BaseQueryProcessor<wm::Entity, armem::query::data::EntityQuery>,
        virtual public base::query_proc::EntityQueryProcessorBase<wm::Entity>
    {
        using Base = BaseQueryProcessor<wm::Entity, armem::query::data::EntityQuery>;

    public:

        EntityQueryProcessor(DataMode dataMode = DataMode::WithData);
        virtual ~EntityQueryProcessor() override;

        data::Entity processToIce(const armem::query::data::EntityQuery& query, const wm::Entity& entity) const;


    private:

        void addResultSnapshot(wm::Entity& result, wm::Entity::ContainerT::const_iterator it) const override;
        void addResultSnapshot(wm::Entity& result, const wm::EntitySnapshot& snapshot) const override;

    };

}
