#include "ProviderSegmentQueryProcessor.h"

#include <RobotAPI/libraries/armem/core/workingmemory/ice_conversions.h>


namespace armarx::armem::wm::query_proc
{

    ProviderSegmentQueryProcessor::ProviderSegmentQueryProcessor(DataMode dataMode) :
        Base(dataMode), entityProcessor(dataMode)
    {}


    ProviderSegmentQueryProcessor::~ProviderSegmentQueryProcessor() = default;


    data::ProviderSegment ProviderSegmentQueryProcessor::processToIce(const armem::query::data::ProviderSegmentQuery& query, const wm::ProviderSegment& providerSegment) const
    {
        data::ProviderSegment data;
        toIce(data, process(query, providerSegment));
        return data;
    }


    Entity ProviderSegmentQueryProcessor::entityProcessorProcess(const armem::query::data::EntityQuerySeq& q, const Entity& s) const
    {
        return entityProcessor.process(q, s, {armem::query::data::QueryTarget::WM});
    }

}
