#include "MemoryControlWidget.h"

#include <QPushButton>
#include <QLineEdit>
#include <QTimer>
#include <QHBoxLayout>

#include <cmath>


namespace armarx::armem::gui
{

    MemoryControlWidget::MemoryControlWidget()
    {
        setSizePolicy(QSizePolicy::Policy::Minimum, QSizePolicy::Policy::Fixed);

        auto vlayout = new QVBoxLayout();
        auto hlayout = new QHBoxLayout();

        const int margin = 0;
        vlayout->setContentsMargins(margin, margin, margin, margin);

        _lineEdit = new QLineEdit("/tmp/MemoryExport", this);
        _lineEdit->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Preferred);
        _lineEdit->setMinimumWidth(400);

        _storeOnDiskButton = new QPushButton("Store current result on local Disk", this);

        _storeInLTMButton = new QPushButton("Store current result in LTM", this);

        vlayout->addWidget(_lineEdit);
        hlayout->addWidget(_storeOnDiskButton);
        hlayout->addWidget(_storeInLTMButton);
        vlayout->addItem(hlayout);

        this->setLayout(vlayout);
        // Private connections.

        // Public connections.
        connect(_storeInLTMButton, &QPushButton::pressed, this, &This::storeInLTM);
        connect(_storeOnDiskButton, &QPushButton::pressed, this, &This::storeOnDisk);
    }

    QLineEdit* MemoryControlWidget::pathInputBox()
    {
        return _lineEdit;
    }

    QString MemoryControlWidget::getEnteredPath()
    {
        return _lineEdit->text();
    }

    QPushButton* MemoryControlWidget::storeInLTMButton()
    {
        return _storeInLTMButton;
    }

    QPushButton* MemoryControlWidget::storeOnDiskButton()
    {
        return _storeOnDiskButton;
    }
}

